#include "TForm.h"

TForm::TForm(QWidget *parent, const char *name)
: TFormGUI(parent, name)
{
	// Constructor, put code here that needs to happen when this 
	// object is first created.
   FreeBase = new STFreeBase();
   
   connect(OpenButton,SIGNAL(clicked()),SLOT(OnOpenButton()));
   connect(NewButton,SIGNAL(clicked()),SLOT(OnNewButton()));
   
   // Tipicly you would put new calls to create object that you have
   // declared pointers for in the header file. Here is an example.
   // Timer1 = new QTimer(this,"Timer1");
   
   
   
   // You can put your connect calls any where you want after the creation
   // of an object, here is an example of a connect call. For example.
   // connect(Timer1,SIGNAL(timeout()),SLOT(OnTimer1TimeOut()));
   
   
   
   // Some object require some thing after being created, like a timer, it
   // need to know how often to time out and when to start. As with the timer
   // it should not be started untill the timer has been created and a SLOT
   // has been defined to handle the event of it timeing out.
   // This one will time out ever 60 seconds.
   // Timer1->start(60000,false);
}

TForm::~TForm()
{
   // Destructor, put code here that needs to happen when this 
	// object is destroied.
   delete FreeBase;
}

void TForm::OnOpenButton()
{

}

void TForm::OnNewButton()
{
   //MakeTest();
}

void TForm::MakeTest()
{
   uint ALoopCounter;
   char PrintText[50];
   int PrintNumber;
   int SetNumber;
   
   FreeBase->New();
   FreeBase->AddField("Name = ftString = 60");
   FreeBase->AddField("Phone = ftString = 20");
   FreeBase->AddField("ANumber = ftInt");
   FreeBase->Create("MyFirstTable.fdb");
   FreeBase->Open("MyFirstTable.fdb");

   FreeBase->Append();
   FreeBase->SetValue(1,(void *)"Roy Souther");
   FreeBase->SetValue(2,(void *)"308-3287");
   SetNumber = 3083287;
   FreeBase->SetValue(3,(void *)&SetNumber);
   FreeBase->Post();

   FreeBase->Append();
   FreeBase->SetValue(1,(void *)"Dexter Souther");
   FreeBase->SetValue(2,(void *)"328-0852");
   SetNumber = 11;
   FreeBase->SetValue(3,(void *)&SetNumber);
   FreeBase->Post();
   
   FreeBase->Append();
   FreeBase->SetValue(1,(void *)"Lynette Souther");
   FreeBase->SetValue(2,(void *)"328-0852");
   SetNumber++;
   FreeBase->SetValue(3,(void *)&SetNumber);
   FreeBase->Post();   

   FreeBase->Append();
   FreeBase->SetValue(1,(void *)"Tom Frank");
   FreeBase->SetValue(2,(void *)"328-0852");
   SetNumber++;
   FreeBase->SetValue(3,(void *)&SetNumber);
   FreeBase->Post();   

   FreeBase->Append();
   FreeBase->SetValue(1,(void *)"Bill Farr");
   FreeBase->SetValue(2,(void *)"328-0152");
   SetNumber++;
   FreeBase->SetValue(3,(void *)&SetNumber);
   FreeBase->Post();   
   
   FreeBase->Append();
   FreeBase->SetValue(1,(void *)"Rick Summer");
   FreeBase->SetValue(2,(void *)"328-0852");
   SetNumber++;
   FreeBase->SetValue(3,(void *)&SetNumber);
   FreeBase->Post();   

   FreeBase->Append();
   FreeBase->SetValue(1,(void *)"Super Man");
   FreeBase->SetValue(2,(void *)"328-0852");
   SetNumber++;
   FreeBase->SetValue(3,(void *)&SetNumber);
   FreeBase->Post();   

   FreeBase->Append();
   FreeBase->SetValue(1,(void *)"Joe Wall");
   FreeBase->SetValue(2,(void *)"328-0852");
   SetNumber++;
   FreeBase->SetValue(3,(void *)&SetNumber);
   FreeBase->Post();   

   FreeBase->Append();
   FreeBase->SetValue(1,(void *)"Frank Tall");
   FreeBase->SetValue(2,(void *)"328-0852");
   SetNumber++;
   FreeBase->SetValue(3,(void *)&SetNumber);
   FreeBase->Post();   

   FreeBase->Append();
   FreeBase->SetValue(1,(void *)"Lisa Smart");
   FreeBase->SetValue(2,(void *)"328-0852");
   SetNumber++;
   FreeBase->SetValue(3,(void *)&SetNumber);
   FreeBase->Post();   

   FreeBase->Append();
   FreeBase->SetValue(1,(void *)"Nickie Hill");
   FreeBase->SetValue(2,(void *)"328-0852");
   SetNumber++;
   FreeBase->SetValue(3,(void *)&SetNumber);
   FreeBase->Post();   

   FreeBase->Append();
   FreeBase->SetValue(1,(void *)"Last name first");
   FreeBase->SetValue(2,(void *)"328-0852");
   SetNumber++;
   FreeBase->SetValue(3,(void *)&SetNumber);
   FreeBase->Post();   

   FreeBase->Close();   

   FreeBase->Open("MyFirstTable.fdb");
   FreeBase->First();
   for(ALoopCounter = 0;ALoopCounter < FreeBase->RecordCount();ALoopCounter++)
   {
      FreeBase->GetValue(1,PrintText);
      printf("Name = %20s ",PrintText);
      FreeBase->GetValue(2,PrintText);
      printf("\tPhone = %13s",PrintText);
      FreeBase->GetValue(3,&PrintNumber);
      printf("\tNumber = %d\n",PrintNumber);
      FreeBase->Next();
   }
   FreeBase->Close();
}

void TForm::closeEvent(QCloseEvent *EventPointer)
{
   // When the form is closed this function will be called.
   // By default you can allow it to close or you can deny it
   // if you need to.
   EventPointer->accept();
   //EventPointer->ignore();
}

void TForm::showEvent(QShowEvent *EventPointer)
{
   // This function is called when the for is first showed.
   // This code will center the form on the screen, it is commanly used.
   int TopPosition, LeftPosition, FormWidth, FormHeight;
   
   FormWidth = width();
   FormHeight = height();
   LeftPosition = (qApp->desktop()->width() / 2) - (FormWidth / 2);
   TopPosition = (qApp->desktop()->height() / 2) - (FormHeight / 2);
   setGeometry(LeftPosition,TopPosition,FormWidth,FormHeight);     
}

/*
void TForm::OnTimer1TimeOut()
{
   // You could use this function to do things when the timer times out.
}
*/

