#include "STScrollText.h"

STScrollText::STScrollText(QWidget *parent, const char *name)
: QWidget(parent, name,Qt::WStyle_Customize | Qt::WStyle_NoBorder)
{
	UpdateTime = 1000;
	TheTop = 0;
	DotSize = 2;
	BarHeight = 16; 
	ColumnCount = (int)qApp->desktop()->width() / DotSize; 
   FontColor = Qt::green;
	TestRow = BarHeight;
	TestColumn = ColumnCount;
	ScreenUpdate = new QTimer(this,"ScreenUpdate");
	connect(ScreenUpdate,SIGNAL(timeout()),SLOT(AdvanceDisplay()));
   DisplayColumns = new STList();
   NextLetter = new STList();
   BackColor = Qt::black;
   setBackgroundColor(BackColor);
   UpdatingScreen = false;
   Painter = new QPainter(this);
   ProgramRunning = false;
   strcpy(TheText,"this is the text           \0");
   TextIndex = 0; 
}

STScrollText::~STScrollText()
{
   byte *PixRows;
   int ALoopCounter,BLoopCounter;

   //ScreenUpdate->stop();
   ProgramRunning = false;
   while(UpdatingScreen == true);
   for(ALoopCounter = 0; ALoopCounter < DisplayColumns->Count();ALoopCounter++)
   {
      PixRows = (byte *)DisplayColumns->Item(0);
      free(PixRows);
      DisplayColumns->Delete(0);
   }    
   delete DisplayColumns;
   
   for(ALoopCounter = 0; ALoopCounter < NextLetter->Count();ALoopCounter++)
   {
      PixRows = (byte *)NextLetter->Item(0);
      free(PixRows);
      NextLetter->Delete(0);
   }    
   delete NextLetter;
   
}

void STScrollText::LoadLetter(char LetterToLoad)
{
   STStringList FontSetFile;      
   int ALoopCounter,BLoopCounter;
   QString ThisLetterString;
   char DotValue;
   QPalette Palette;
   QButton *ReadButton;
   QPushButton *ColorThisButton;
   bool DefaultTheLine;
   byte *PixRows;
   
   if(LetterToLoad != 0)
   {
      DefaultTheLine = true;
      FontSetFile.LoadFromFile("test.set");
      for(ALoopCounter = 0;ALoopCounter < FontSetFile.Count();ALoopCounter++)
      {
         ThisLetterString = FontSetFile.Item(ALoopCounter);
         if(ThisLetterString.find(LetterToLoad,0,false) == 0)
         {
            DefaultTheLine = false;
            break;
         }
      }
      ThisLetterString.remove(0,ThisLetterString.find(" ",0,false)+1);
      ThisLetterString.remove(0,ThisLetterString.find(" ",0,false)+1);
      ThisLetterString.remove(0,ThisLetterString.find(" ",0,false)+1);
      ThisLetterString.remove(0,ThisLetterString.find(" ",0,false)+1);
      ALoopCounter = 0;
      BLoopCounter = 0;
      //printf("loading dot\n");
      
      while(ThisLetterString.length() > 0)
      {
         PixRows = (byte *)malloc(sizeof(bool) * BarHeight); 
         for(ALoopCounter = 0;ALoopCounter < BarHeight;ALoopCounter++)
         {
            PixRows[ALoopCounter] = 0; 
         }
         NextLetter->Add(PixRows);   
         
         for(ALoopCounter = 0;ALoopCounter < BarHeight;ALoopCounter++)
         {
            DotValue = (QChar)ThisLetterString[0];
            ThisLetterString.remove(0,1);
            if(DotValue == '1')
            {
               PixRows[ALoopCounter] = 1; 
            } else
            if(DotValue == '0')
            {
               PixRows[ALoopCounter] = 0; 
            } else
            if(DotValue == ' ')
            {
               break;
            }
            if(ThisLetterString.length() == 0)
            {
               break;
            }
         }
      }
   }   
}

void STScrollText::GetNextLetter()
{
   int ALoopCounter;
   
   byte *PixRows;
   // Flush remains of old letter.
   for(ALoopCounter = 0; ALoopCounter < NextLetter->Count();ALoopCounter++)
   {
      PixRows = (byte *)NextLetter->Item(0);
      free(PixRows);
      NextLetter->Delete(0);
   }    

   LoadLetter(TheText[TextIndex]);
   TextIndex++;
   if(TextIndex > strlen(TheText))
   {
      TextIndex = 0;
   }   
}

void STScrollText::Stop()
{
   ProgramRunning = false;
}

void STScrollText::Begin()
{	
	int FormWidth, FormHeight, FormLeft;
   byte *PixRows;
   int ALoopCounter,BLoopCounter;

	ColumnCount = (int)qApp->desktop()->width() / DotSize; 
   for(ALoopCounter = 0; ALoopCounter < ColumnCount;ALoopCounter++)
   {
      PixRows = (byte *)malloc(sizeof(bool) * BarHeight); 
      DisplayColumns->Add(PixRows);
      for(BLoopCounter = 0;BLoopCounter < BarHeight;BLoopCounter++)
      {
         PixRows[BLoopCounter] = 0; 
      }
   }
   GetNextLetter();
   
   // Resize the scrolling text bar
	FormWidth = qApp->desktop()->width() + (DotSize * 2);
	FormHeight = BarHeight * DotSize;
	FormLeft = -1 * DotSize;
	setGeometry(FormLeft, TheTop, FormWidth, FormHeight);
	show();

   ScreenUpdate->start(UpdateTime,true);
}

void STScrollText::AdvanceDisplay()
{
   byte *ThisPixColumn;
   byte *NextPixColumn;
   byte *NextLetterColumn;
   int ALoopCounter,BLoopCounter;
	int XPosition, YPosition;
   QColor Color;
   
   UpdatingScreen = true;
   ProgramRunning = true;
   while(ProgramRunning == true)
   {
	  // Advance the display, Find boxes that changed Redraw changed boxes
     for(ALoopCounter = 0; ALoopCounter < ColumnCount-1;ALoopCounter++)
     {
        ThisPixColumn = (byte *)DisplayColumns->Item(ALoopCounter); 
        NextPixColumn = (byte *)DisplayColumns->Item(ALoopCounter + 1);
        for(BLoopCounter = 0;BLoopCounter < BarHeight;BLoopCounter++)
        {
           if(ThisPixColumn[BLoopCounter] != NextPixColumn[BLoopCounter])
           {
              ThisPixColumn[BLoopCounter] = NextPixColumn[BLoopCounter];
              if(ThisPixColumn[BLoopCounter] == 1)
              {
                 Color = FontColor;
                 Painter->setPen(Color);            
              } else
              {
                 Color = BackColor;
                 Painter->setPen(Color);         
              }
              XPosition = ALoopCounter * DotSize;
              YPosition = BLoopCounter * DotSize;
              Painter->fillRect(XPosition,YPosition,DotSize,DotSize,Color);	
              repaint(XPosition,YPosition,DotSize,DotSize,false);
           }
        }
     }
     qApp->processEvents();
     
     // Load next column of dots
     if(NextLetter->Count() > 0)
     {
        NextLetterColumn = (byte *)NextLetter->Item(0);
        NextLetter->Delete(0);
     }
     for(BLoopCounter = 0;BLoopCounter < BarHeight;BLoopCounter++)
     {
        NextPixColumn[BLoopCounter] = NextLetterColumn[BLoopCounter];
     }
     if(NextLetter->Count() < 1)
     {
        GetNextLetter();
     }
   }
   UpdatingScreen = false;
}


