#include "TForm.h"

TForm::TForm(QWidget *parent, const char *name)
: TFormGUI(parent, name)
{
	// Constructor, put code here that needs to happen when this 
	// object is first created.
   StockTicker = new STScrollText(0,"StockTicker");
   StockTicker->Begin();
   
   // Tipicly you would put new calls to create object that you have
   // declared pointers for in the header file. Here is an example.
   // Timer1 = new QTimer(this,"Timer1");
   
   
   
   // You can put your connect calls any where you want after the creation
   // of an object, here is an example of a connect call. For example.
   // connect(Timer1,SIGNAL(timeout()),SLOT(OnTimer1TimeOut()));
   
   
   
   // Some object require some thing after being created, like a timer, it
   // need to know how often to time out and when to start. As with the timer
   // it should not be started untill the timer has been created and a SLOT
   // has been defined to handle the event of it timeing out.
   // This one will time out ever 60 seconds.
   // Timer1->start(60000,false);
}

TForm::~TForm()
{
   // Destructor, put code here that needs to happen when this 
	// object is destroied.
   delete StockTicker;
}

void TForm::closeEvent(QCloseEvent *EventPointer)
{
   // When the form is closed this function will be called.
   // By default you can allow it to close or you can deny it
   // if you need to.
   StockTicker->Stop();
   EventPointer->accept();
   //EventPointer->ignore();
}

void TForm::showEvent(QShowEvent *EventPointer)
{
   // This function is called when the for is first showed.
   // This code will center the form on the screen, it is commanly used.
   int TopPosition, LeftPosition, FormWidth, FormHeight;
   
   FormWidth = width();
   FormHeight = height();
   LeftPosition = (qApp->desktop()->width() / 2) - (FormWidth / 2);
   TopPosition = (qApp->desktop()->height() / 2) - (FormHeight / 2);
   setGeometry(LeftPosition,TopPosition,FormWidth,FormHeight);     
}

/*
void TForm::OnTimer1TimeOut()
{
   // You could use this function to do things when the timer times out.
}
*/

