/*=============================================================================

    Copyright (C) 2001 Silicon Tao Technology Systems
    E-mail:  Support <support@silicontao.com>
    Web:     www.silicontao.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
=============================================================================*/

#ifndef STCheckBoxItem_included
#define STCheckBoxItem_included

#include <SiliconTaoLibs.h>

/**
 * A decendent of QListViewItem to back a tri state QCheckListItem replacment.
 *
 * @short A check box list item with tri state.
 */   
class STCheckBoxItem:public QListViewItem
{
   private:
      int CurrentState;
      QPixmap *(CustomIconSet[20]);
      
   public:
      STCheckBoxItem( QListView * parent );
      STCheckBoxItem( STCheckBoxItem * parent );
      STCheckBoxItem( QListView * parent, STCheckBoxItem * after );
      STCheckBoxItem( STCheckBoxItem * parent, STCheckBoxItem * after );

      STCheckBoxItem( QListView * parent,
		   QString,     QString = QString::null,
		   QString = QString::null, QString = QString::null,
		   QString = QString::null, QString = QString::null,
		   QString = QString::null, QString = QString::null );
      STCheckBoxItem( STCheckBoxItem * parent,
		   QString,     QString = QString::null,
		   QString = QString::null, QString = QString::null,
		   QString = QString::null, QString = QString::null,
		   QString = QString::null, QString = QString::null );

      STCheckBoxItem( QListView * parent, STCheckBoxItem * after,
		   QString,     QString = QString::null,
		   QString = QString::null, QString = QString::null,
		   QString = QString::null, QString = QString::null,
		   QString = QString::null, QString = QString::null );
      STCheckBoxItem( STCheckBoxItem * parent, STCheckBoxItem * after,
		   QString,     QString = QString::null,
		   QString = QString::null, QString = QString::null,
		   QString = QString::null, QString = QString::null,
		   QString = QString::null, QString = QString::null );
      
      void PrepairIcons();
      void SetState(int NewState);
      int GetState();   
      void SetCustomIcon(QPixmap *CustomIcon);
      void SetIcon(int IconIndex);
};

#endif // STCheckBoxItem_included
