/*=============================================================================

    Copyright (C) 2001 Silicon Tao Technology Systems
    E-mail:  Support <support@silicontao.com>
    Web:     www.silicontao.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
=============================================================================*/

/*=============================================================================
   File Name:					STIntList.h
	Object Name:				STIntList
   Programmer Name:			Roy Souther
   By Command of:				Silicon Tao Technology Systems
   License:						GNU general public license. See GNU.
   Day Zero:					02152000, Feburary 15, 2000
   Target Platform:			Linux
   Registors Used:       
   Compiler Used:        	GNU g++
   Compiled Settings:    
   Resources Used:       
   Libraries Used:       	alloc.h
   Ports Used:           	None
   Title of program:			Object library
   Discription:				Basic linked list for integers
=============================================================================*/
#ifndef STIntList_included 
#define STIntList_included 

// Do not use STMalloc here, would cause recursive loop.
#include <alloc.h>
#include <STCommanCore.h>
#include <STList.h>

/**
 * A list for integers. Of all the list that could be used I find that the two
 * I use the most are String lists and Integer lists.
 *
 * @short Integer listing. 
 */   
class STIntList: public STList
{
   public:
      /**
       * Add an integer to the list.
       */   
      void Add(int NewInt);

      /**
       * Delete an integer from the list.
       */   
      void Delete(int CellToKill);

      /**
       * Delete all integers from the list.
       */   
      void Clear();

      /**
       * Retreive an integer from the list.
       */   
      int Item(int ItemIndex);
      
      /**
       * Constructor
       */   
      STIntList();
      
      /**
       * Destructor
       */   
      ~STIntList();
};

#endif // STIntList_included 
