/*=============================================================================

    Copyright (C) 2001 Silicon Tao Technology Systems
    E-mail:  Support <support@silicontao.com>
    Web:     www.silicontao.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
=============================================================================*/

/*=============================================================================
   File Name:					STMalloc.h
   Object Name: 				STMalloc
   Programmer Name:			Roy Souther
   By Command of:				Silicon Tao Technology Systems
   License:						GNU general public license. See GNU.
   Day Zero:					02152000, Feburary 15, 2000
   Target Platform:			Linux
   Registors Used:
   Compiler Used:        	GNU g++
   Compiled Settings:
   Resources Used:
   Libraries Used:      	
   Ports Used:           	None
   Title of program:			Object library
   Discription:				Provides C++ functionality of malloc and free.
  									Does not free the same memory more then once and
                           reports if memory not freed at destroy time.
=============================================================================*/

#ifndef STObjectController_included
#define STObjectController_included

#include <stdio.h>

/**
 * Provides a methode to track and control decendent objects.
 * It does not work now but I would like to make it work soon.
 *
 * @short The parent of all ST objects.
 */   
class STObjectController
{
   public:
      int DebugLevel;

      void SetDebugLevel(int NewLevel);
      
      /**
       * Constructor
       */   
		STObjectController();

      /**
       * Destructor
       */   
      ~STObjectController();
};

#endif // STObjectController_included
