/*=============================================================================

    Copyright (C) 2001 Silicon Tao Technology Systems
    E-mail:  Support <support@silicontao.com>
    Web:     www.silicontao.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
=============================================================================*/

#ifndef STPasswordDialog_included
#define STPasswordDialog_included

#include <AllThingsQt.h>
#include <STPasswordDialogGUI.h>

/**
 * A simple password dialog box. You should not call this directly unless you need some
 * non-standard functionality. You should use @ref STDialogs::Password
 *
 * @short A simple password dialog box.
 */   
class STPasswordDialog: public STPasswordDialogGUI
{
   Q_OBJECT
   private:
      QString ThePassword;
      bool UserHasSelected;
      
   public:

      /**
       * 
       */   
      STPasswordDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );

      /**
       * 
       */   
      ~STPasswordDialog();
      
      /**
       *
       */
      QString UserEnteredPassword();
   protected:
      virtual void closeEvent(QCloseEvent *EventPointer);

   private slots:
      void OnEnterButtonClick();
      void OnQuitButtonClick();

};

#endif // STPasswordDialog_included
