#ifndef STPortDialog_included
#define STPortDialog_included

#include <AllThingsQt.h>
#include <STWidgetsEx.h>
#include <STXcom.h>
#include <STSuperIni.h>
#include <STPortDialogGUI.h>

/**
 * This dialog can be used to set, read and store port settings.
 * Port settings are stored in a local INI file.
 *
 * See also @ref STSuperIni
 *
 * @short Serial port settings dialog. 
 */   
class STPortDialog: public STPortDialogGUI
{
   Q_OBJECT
   public:
      // Object pointer here 
      STSuperIni *SuperIniSettings;   

      // Object declairations here
      QString ReturnSting;
    
      // Non-object declairations here
      bool PortIsActive;
      bool PortSettingsChanged; 
      int DebugLevel;
    
      // Member functions here
      /**
       * 
       */   
      bool SetDebugLevel(int NewDebugLevel);

      /**
       * 
       */   
      void SetPortSelectValues();

      /**
       * 
       */   
      void SetPortSpeedValue();

      /**
       * 
       */   
      void SetDataBitsValue();

      /**
       * 
       */   
      void SetParitySelectValue();

      /**
       * 
       */   
      void SetStopBitsValue();

      /**
       * 
       */   
      void LoadLastPortSettings();

      /**
       * 
       */   
      int GetBaud();

      /**
       * 
       */   
      int GetParity();

      /**
       * 
       */   
      int GetDataBits();

      /**
       * 
       */   
      int GetStopBits();

      /**
       * 
       */   
      QString GetPort();

      /**
       * 
       */   
      void SetActive(bool ActiveState);

      /**
       * 
       */   
      STPortDialog(QWidget *parent, const char *name);

      /**
       * 
       */   
      ~STPortDialog();
   public slots:  
      /**
       * 
       */   
      void OnPortOnOffClick();

      /**
       * 
       */   
      void OnPortSettingsChanged();
   signals:

      /**
       * 
       */   
      void ActiveChange(bool ActiveState);
};

#endif
