/*=============================================================================

    Copyright (C) 2001 Silicon Tao Technology Systems
    E-mail:  Support <support@silicontao.com>
    Web:     www.silicontao.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
=============================================================================*/

#ifndef STPortMap_included
#define STPortMap_included

#include <STCommanCore.h>

#ifndef BYTE
#define BYTE unsigned short int
#endif // BYTE 

/**
 * Provides PORT I/O pin simulation for embeded chip emulators.
 *
 * @short Provides PORT I/O pin simulation for embeded chip emulators.
 */   
class STPortMap
{
   public:
      BYTE PortValue;
      
      bool BIT7,BIT6,BIT5,BIT4,BIT3,BIT2,BIT1,BIT0;
   
      STPortMap &operator=(const BYTE NewValue);
      STPortMap &operator++(int);
      STPortMap &operator+(const int Incroment);
      STPortMap &operator+=(const int Incroment);
      STPortMap &operator+=(const STPortMap& );
      STPortMap &operator>>=(const int RotateRight);
      STPortMap &operator<<=(const int RotateLeft);
      STPortMap &operator|=(const int OrValue);
      STPortMap &operator&=(const int AndValue);
      STPortMap &operator!=(const int NotValue);
      operator BYTE();      
      
      void SetPort();
      void SetBits(BYTE NewBits);

};

#endif // STPortMap_included
