/*=============================================================================

    Copyright (C) 2001 Silicon Tao Technology Systems
    E-mail:  Support <support@silicontao.com>
    Web:     www.silicontao.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
=============================================================================*/

/*=============================================================================
   File Name:					STSuperIni.h
   Object Name:				STSuperIni
   Programmer Name:			Roy Souther
   By Command of:				Silicon Tao Technology Systems
   License:						GNU general public license. See GNU.
   Day Zero:					02152000, Feburary 15, 2000
   Target Platform:			Linux
   Registors Used:       
   Compiler Used:        	GNU g++
   Compiled Settings:    
   Resources Used:       
   Libraries Used:       	alloc.h, stdio.h, string.h
   Ports Used:           	None
   Title of program:			Object library
   Discription:				Bass linked list
=============================================================================*/

#ifndef STSuperIni_included
#define STSuperIni_included

#include <STCommanCore.h>
#include <AllThingsQt.h>
#include <STStringList.h>
#include <STStringsEx.h>

/**
 * This object uses the SiliconTao SuperIni configuration text file style.
 * 
 * Data in these files is stored as <NAME> = <VALUE>
 *
 * @short Ini & configuration text file controler.
 */   
class STSuperIni: public STStringList
{
   public:
      // Non-object declairations here
      int DebugLevel;

      // Object pointer here 


      // Object declairations here
      QString SifFileName, RuturnString;
   
      // Member functions here

      /**
       * 
       */   
      bool SetDebugLevel(int NewDebugLevel);

      /**
       * 
       */   
      STSuperIni(QString &PreSetFileName);

      /**
       * 
       */   
      STSuperIni(const char *PreSetFileName);

      /**
       * 
       */   
      void InitSTSuperIni(QString &PreSetFileName);

      /**
       * 
       */   
      ~STSuperIni();

      /**
       * 
       */   
      bool GetCheck(QString &ValueName);

      /**
       * 
       */   
      QString GetValue(QString &ValueName);

      /**
       * 
       */   
      QString GetValue(const char *ValueName);

      /**
       * 
       */   
      QString GetValueDef(QString &ValueName,QString &DefaultValue);

      /**
       * 
       */   
      QString GetValueDef(const char *ValueName,QString &DefaultValue);

      /**
       * 
       */   
      QString GetValueDef(const char *ValueName,const char *DefaultValue);

      /**
       * 
       */   
      QString GetValueDef(QString &ValueName,const char *DefaultValue);

      /**
       * 
       */   
      void SetCheck(QString &ValueName,bool Value);

      /**
       * 
       */   
      void SetValue(QString &ValueName,QString &Value);

      /**
       * 
       */   
      void SetValue(const char *ValueName,QString &Value);

      /**
       * 
       */   
      void SetValue(QString &ValueName,const char *Value);

      /**
       * 
       */   
      void SetValue(const char *ValueName,const char *Value);
};

#endif // STSuperIni_included
