/*=============================================================================

    Copyright (C) 2001 Silicon Tao Technology Systems
    E-mail:  Support <support@silicontao.com>
    Web:     www.silicontao.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
=============================================================================*/

/*=============================================================================
   File Name:					STSystemAPI.h
   Object Name: 				STSystemAPI
   Programmer Name:			Roy Souther
   By Command of:				Silicon Tao Technology Systems
   License:						GNU general public license. See GNU.
   Day Zero:					02152000, Feburary 15, 2000
   Target Platform:			Linux
   Registors Used:       
   Compiler Used:        	GNU g++
   Compiled Settings:    
   Resources Used:       
   Libraries Used:      	STList.h
   Ports Used:           	None
   Title of program:			Object library
   Discription:				
=============================================================================*/

#ifndef STSystemAPI_included
#define STSystemAPI_included

#include <STCommanCore.h>
#include <STIntList.h>
#include <STStringList.h>
#include <AllThingsQt.h>
#include <errno.h>
#include <alloc.h>
#include <unistd.h>
#include <netdb.h>
//#include <stdio.h>
#include <dirent.h>
#include <ctype.h>
#include <fcntl.h>
//#include <stdlib.h>
//#include <string.h>
#include <sys/stat.h>
//#include <sys/types.h> 

/**
 * Things for Linux.
 *
 * @short Simple interfacing to command Linux functions.
 */   
class STSystemAPI
{
   private:
      QString ReturnString;
   protected:
      //
   public:
      /**
       * Returns PID for the running app
       */   
      int GetAppPid();
      
      /**
       * Fills a list with PID's for all app with the name AppName.
       * If HoleMatch == true AppName must match, if false it must contain.
       */   
      void GetPidList(QString &AppName, STIntList *PidList,bool HoleMatch);

      /**
       * 
       */   
      QString GetAppNameFromPid(int ProcessID);

      /**
       * Fills a given STStringList with IP addresses of the system.
       */   
      void GetIpAddresses(STStringList *FillAddressList);

      /**
       * Constructor
       */   
      STSystemAPI();

      /**
       * Destructor
       */   
      ~STSystemAPI();      
};

#endif // STSystemAPI_included
