/*=============================================================================

    Copyright (C) 2001 Silicon Tao Technology Systems
    E-mail:  Support <support@silicontao.com>
    Web:     www.silicontao.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
=============================================================================*/

/*=============================================================================
   ToDo:
      - convert char*'s to QString's if needed
      - run in own thread, pass data in by stream

=============================================================================*/

#include <STAppLogging.h>

int STAppLogging::ClearLog(void)
{
   char *SystemCommand;
   
   SystemCommand=(char *)malloc(sizeof(LogFile)+20);

   // Remove old file
   strcpy(SystemCommand,"rm -f \"");
   strcat(SystemCommand,LogFile);
   strcat(SystemCommand,"\"");
   printf("%s\n",SystemCommand);
   system(SystemCommand);

   // Create a new one, make me the owner
   strcpy(SystemCommand,"echo \"\" > \"");
   strcat(SystemCommand,LogFile);
   strcat(SystemCommand,"\"");
   system(SystemCommand);
   
   ShareFileWithEveryOne();
   
   free(SystemCommand);
   return(0);
}

int STAppLogging::ShareFileWithEveryOne()
{
   char *SystemCommand;

   SystemCommand=(char *)malloc(sizeof(LogFile)+20);

   // Let others use it
   strcpy(SystemCommand,"chmod 666 \"");
   strcat(SystemCommand,LogFile);
   strcat(SystemCommand,"\"");
   system(SystemCommand);

   free(SystemCommand);

   return(0);
}

int STAppLogging::Log(QString &TextToLog)
{
   char *TempChars;
   int TempReturn;
   
   TempChars = (char *)malloc(TextToLog.length()+1);
   TempChars[TextToLog.length()]='\0';   
   TempReturn = Log(TempChars);
   free(TempChars);
   return(TempReturn);
}

int STAppLogging::Log(const char *TextToLog)
{
   char *WritingString;
   FILE *FilePointer;

   if(LoggingOn==true) 
   {
      WritingString=(char *)malloc(sizeof(WritingString)+2+20);
      // strcpy(WritingString,Date & Time);
      strcpy(WritingString,TextToLog);
      strcat(WritingString,"\n\0");
   
      FilePointer=fopen(LogFile,"a");
      fprintf(FilePointer,WritingString);
      fclose(FilePointer);
      free(WritingString);
   }
   return(0);
}

STAppLogging::~STAppLogging()
{
   free(LogFile);
   free(LogFilePath);
}

STAppLogging::STAppLogging()
{
   char DefaultLogFileName[]="AppLog.txt";
   char DefaultLogFilePath[]="./";
   
   LoggingOn=false;
   LogFile=(char *)malloc(sizeof(DefaultLogFileName)+1);
   strcpy(LogFile,DefaultLogFileName);
   
   LogFilePath=(char *)malloc(sizeof(DefaultLogFilePath)+1);
   strcpy(LogFilePath,DefaultLogFilePath);
}

int STAppLogging::SetLogFileName(const char *NewName)
{
   QString EditingString;
   
   EditingString=NewName;
   while(EditingString.find('/',0,false) > -1)
   {
      EditingString.remove(0,EditingString.find('/',0,false)+1);
   }
   if(EditingString.length() > 0)
   {
      free(LogFile);
      LogFile = (char *)malloc(EditingString.length()+1);
      strcpy(LogFile,EditingString);
      
   }   
   return(0);
}

int STAppLogging::SetLogFileName(QString &NewName)
{
   char *TempChars;
   int TempReturn;
   
   TempChars = (char *)malloc(NewName.length()+1);
   TempChars[NewName.length()]='\0';   
   TempReturn = SetLogFileName(TempChars);
   free(TempChars);
   return(TempReturn);
}
