/*=============================================================================

    Copyright (C) 2001 Silicon Tao Technology Systems
    E-mail:  Support <support@silicontao.com>
    Web:     www.silicontao.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
=============================================================================*/

/*=============================================================================
   ToDo:

=============================================================================*/

#include <STCheckBoxItem.h>

// Dark Blue	#000000808080
// Black 		#000000000000
// Light Blue  #000000FFFFFF
// White 		#FFFFFFFFFFFF
// Dark Grey 	#808080808080
// Light Grey	#DEDEDEDEDEDE
// Yello 		#FFFFFFFF0000
// Background None

static const char * const CheckBoxStateXpmOff[] = {
"16 16 4 1",
" 	c None",
".	c #000000000000",
"X	c #FFFFFFFFFFFF",
"o	c #808080808080",
"                ",
"................",
"................",
"..XXXXXXXXXXXX..",
"..XXXXXXXXXXXX..",
"..XXXXXXXXXXXX..",
"..XXXXXXXXXXXX..",
"..XXXXXXXXXXXX..",
"..XXXXXXXXXXXX..",
"..XXXXXXXXXXXX..",
"..XXXXXXXXXXXX..",
"..XXXXXXXXXXXX..",
"..XXXXXXXXXXXX..",
"..XXXXXXXXXXXX..",
"................",
"................",
"                "};

static const char * const CheckBoxStateXpmOn[] = {
"16 16 4 1",
" 	c None",
".	c #000000000000",
"X	c #FFFFFFFFFFFF",
"o	c #808080808080",
"                ",
"................",
"................",
"..XXXXXXXXXXXX..",
"..XXXXXXXXXXXX..",
"..XXXXXXXXXX.X..",
"..XXXXXXXXX..X..",
"..XXXXXXXX..XX..",
"..XXXXXXX..XXX..",
"..X.XXXX..XXXX..",
"..X..XX..XXXXX..",
"..XX....XXXXXX..",
"..XXX..XXXXXXX..",
"..XXXXXXXXXXXX..",
"................",
"................",
"                "};

static const char * const CheckBoxStateXpmTri[] = {
"16 16 4 1",
" 	c None",
".	c #000000000000",
"X	c #FFFFFFFFFFFF",
"o	c #808080808080",
"                ",
"................",
"................",
"..oooooooooooo..",
"..oooooooooooo..",
"..oooooooooo.o..",
"..ooooooooo..o..",
"..oooooooo..oo..",
"..ooooooo..ooo..",
"..o.oooo..oooo..",
"..o..oo..ooooo..",
"..oo....oooooo..",
"..ooo..ooooooo..",
"..oooooooooooo..",
"................",
"................",
"                "};

static const char * const ClosedFolderXpm[] = {
"16 16 4 1",
" 	c None",
".	c #DEDEDEDEDEDE",
"X	c #000000000000",
"o	c #FFFFFFF00000",
"                ",
"................",
"..XXXXX.........",
".XoooooX........",
"XoooooooXXXXX...",
"XooooooooooooX..",
"XooooooooooooX..",
"XooooooooooooX..",
"XooooooooooooX..",
"XooooooooooooX..",
"XooooooooooooX..",
"XooooooooooooX..",
"XooooooooooooX..",
"XooooooooooooX..",
"XXXXXXXXXXXXXX..",
"                "};

static const char * const OpenFolderXpm[] = {
"16 16 4 1",
" 	c None",
".	c #DEDEDEDEDEDE",
"X	c #000000000000",
"o	c #FFFFFFF00000",
"                ",
"................",
"..XXXXX.........",
".XoooooX........",
"XoooooooXXXXX...",
"XooooooooooooX..",
"XooXXXXXoooooX..",
"XooXooooXXXXXXXX",
"XooXoooooooooooX",
"XoXoooooooooooX.",
"XoXoooooooooooX.",
"XXoooooooooooX..",
"XXoooooooooooX..",
"XoooooooooooXX..",
"XXXXXXXXXXXXXX..",
"                "};

static const char * const UnknownFileXpm[] = {
"16 16 4 1",
" 	c None",
".	c #000000000000",
"W	c #FFFFFFFFFFFF",
"o	c #000000808080",
"                ",
"................",
".WWWWWWWWWWWWWW.",
".WWWWoooooWWWWW.",
".WWWoooooooWWWW.",
".WWooWWWWWooWWW.",
".WWooWWWWWooWWW.",
".WWWooWWWooWWWW.",
".WWWWWWWooWWWWW.",
".WWWWWWooWWWWWW.",
".WWWWWWooWWWWWW.",
".WWWWWWooWWWWWW.",
".WWWWWWWWWWWWWW.",
".WWWWWWooWWWWWW.",
".WWWWWWWWWWWWWW.",
"................",
"                "};

static const char * const BinaryFileXpm[] = {
"16 16 4 1",
" 	c None",
".	c #000000000000",
"X	c #FFFFFFFFFFFF",
"o	c #808080808080",
"                ",
"................",
"................",
"..oooooooooooo..",
"..oooooooooooo..",
"..oooooooooo.o..",
"..ooooooooo..o..",
"..oooooooo..oo..",
"..ooooooo..ooo..",
"..o.oooo..oooo..",
"..o..oo..ooooo..",
"..oo....oooooo..",
"..ooo..ooooooo..",
"..oooooooooooo..",
"................",
"................",
"                "};

static const char * const TextFileXpm[] = {
"16 16 4 1",
" 	c None",
".	c #000000000000",
"X	c #FFFFFFFFFFFF",
"o	c #808080808080",
"                ",
"................",
"................",
"..oooooooooooo..",
"..oooooooooooo..",
"..oooooooooo.o..",
"..ooooooooo..o..",
"..oooooooo..oo..",
"..ooooooo..ooo..",
"..o.oooo..oooo..",
"..o..oo..ooooo..",
"..oo....oooooo..",
"..ooo..ooooooo..",
"..oooooooooooo..",
"................",
"................",
"                "};

static const char * const MediaCdXpm[] = {
"16 16 4 1",
" 	c None",
".	c #000000000000",
"X	c #FFFFFFFFFFFF",
"o	c #000000808080",
"                ",
"XXXXXXXXXXXXXXXX",
"XXXXXX....XXXXXX",
"XXXX..XXXX..XXXX",
"XXX.XXoXXXXX.XXX",
"XX.XoXoXXXXXX.XX",
"XX.XXoXoXXXXX.XX",
"X.XXXXoXXXXXXX.X",
"X.XXXXX..XXXXX.X",
"X.XXXXX..XoXXX.X",
"XX.XXXXXXoXoX.XX",
"XX.XXXXXXoXXo.XX",
"XXX.XXXXXXoX.XXX",
"XXXX..XXXX..XXXX",
"XXXXXX....XXXXXX",
"XXXXXXXXXXXXXXXX",
"                "};

static const char * const MediaFloppyXpm[] = {
"16 16 4 1",
" 	c None",
".	c #000000000000",
"X	c #FFFFFFFFFFFF",
"o	c #808080808080",
"                ",
"................",
"................",
"..oooooooooooo..",
"..oooooooooooo..",
"..oooooooooo.o..",
"..ooooooooo..o..",
"..oooooooo..oo..",
"..ooooooo..ooo..",
"..o.oooo..oooo..",
"..o..oo..ooooo..",
"..oo....oooooo..",
"..ooo..ooooooo..",
"..oooooooooooo..",
"................",
"................",
"                "};

static const char * const MediaHardDiskXpm[] = {
"16 16 4 1",
" 	c None",
".	c #000000000000",
"X	c #FFFFFFFFFFFF",
"o	c #808080808080",
"                ",
"................",
"................",
"..oooooooooooo..",
"..oooooooooooo..",
"..oooooooooo.o..",
"..ooooooooo..o..",
"..oooooooo..oo..",
"..ooooooo..ooo..",
"..o.oooo..oooo..",
"..o..oo..ooooo..",
"..oo....oooooo..",
"..ooo..ooooooo..",
"..oooooooooooo..",
"................",
"................",
"                "};

static const char * const MediaNetworkXpm[] = {
"16 16 4 1",
" 	c None",
".	c #000000000000",
"X	c #FFFFFFFFFFFF",
"o	c #808080808080",
"                ",
"................",
"................",
"..oooooooooooo..",
"..oooooooooooo..",
"..oooooooooo.o..",
"..ooooooooo..o..",
"..oooooooo..oo..",
"..ooooooo..ooo..",
"..o.oooo..oooo..",
"..o..oo..ooooo..",
"..oo....oooooo..",
"..ooo..ooooooo..",
"..oooooooooooo..",
"................",
"................",
"                "};

static const char * const MediaDatabaseXpm[] = {
"16 16 4 1",
" 	c None",
".	c #000000000000",
"X	c #FFFFFFFFFFFF",
"o	c #808080808080",
"                ",
"................",
"................",
"..oooooooooooo..",
"..oooooooooooo..",
"..oooooooooo.o..",
"..ooooooooo..o..",
"..oooooooo..oo..",
"..ooooooo..ooo..",
"..o.oooo..oooo..",
"..o..oo..ooooo..",
"..oo....oooooo..",
"..ooo..ooooooo..",
"..oooooooooooo..",
"................",
"................",
"                "};

STCheckBoxItem::STCheckBoxItem( QListView * parent )
:QListViewItem(parent)
{
   PrepairIcons();
}

STCheckBoxItem::STCheckBoxItem( STCheckBoxItem * parent )
:QListViewItem(parent)
{
   PrepairIcons();
}

STCheckBoxItem::STCheckBoxItem( QListView * parent, STCheckBoxItem * after )
:QListViewItem(parent,after)
{
   PrepairIcons();
}

STCheckBoxItem::STCheckBoxItem( STCheckBoxItem * parent, STCheckBoxItem * after )
:QListViewItem(parent,after)
{
   PrepairIcons();
}

STCheckBoxItem::STCheckBoxItem( QListView * parent,QString label1, QString label2, QString label3, 
   QString label4, QString label5, QString label6, QString label7, QString label8 )
:QListViewItem(parent,label1,label2,label3,label4,label5,label6,label7,label8)
{
   PrepairIcons();
}

STCheckBoxItem::STCheckBoxItem( STCheckBoxItem * parent, QString label1, QString label2, QString label3, 
   QString label4, QString label5, QString label6, QString label7, QString label8 )
:QListViewItem(parent,label1,label2,label3,label4,label5,label6,label7,label8)
{
   PrepairIcons();
}

STCheckBoxItem::STCheckBoxItem( QListView * parent, STCheckBoxItem * after, QString label1, QString label2,
   QString label3, QString label4, QString label5, QString label6, QString label7, QString label8 )
:QListViewItem(parent,after,label1,label2,label3,label4,label5,label6,label7,label8)
{
   PrepairIcons();
}

STCheckBoxItem::STCheckBoxItem( STCheckBoxItem * parent, STCheckBoxItem * after, QString label1, QString label2,
   QString label3, QString label4, QString label5, QString label6, QString label7, QString label8 )
:QListViewItem(parent,after,label1,label2,label3,label4,label5,label6,label7,label8)
{
   PrepairIcons();
}

void STCheckBoxItem::SetCustomIcon(QPixmap *CustomIcon)
{
   //setPixmap(0,CustomIcon);
}

void STCheckBoxItem::SetIcon(int IconIndex)
{
   setPixmap(0,*(CustomIconSet[IconIndex]));
}

void STCheckBoxItem::SetState(int NewState)
{
   CurrentState = NewState;
   if(CurrentState > 2)
   {
      CurrentState = 2;
   }
   if(CurrentState < 0)
   {
      CurrentState = 0;
   }
   setPixmap(0,*(CustomIconSet[CurrentState]));
}

int STCheckBoxItem::GetState()
{
   if((CurrentState > 2)||(CurrentState < 0))
   {
      CurrentState = 0;
   }
   return(CurrentState);
}

void STCheckBoxItem::PrepairIcons()
{
   CurrentState = 0;
   // Tri state check box icons
   CustomIconSet[0] = new QPixmap((const char **)CheckBoxStateXpmOff);
   CustomIconSet[1] = new QPixmap((const char **)CheckBoxStateXpmOn);
   CustomIconSet[2] = new QPixmap((const char **)CheckBoxStateXpmTri);  
   
   // Other comman icons
   CustomIconSet[3] = new QPixmap((const char **)ClosedFolderXpm);  
   CustomIconSet[4] = new QPixmap((const char **)OpenFolderXpm);  
   CustomIconSet[5] = new QPixmap((const char **)UnknownFileXpm);  
   CustomIconSet[6] = new QPixmap((const char **)BinaryFileXpm);  
   CustomIconSet[7] = new QPixmap((const char **)TextFileXpm);  
   CustomIconSet[7] = new QPixmap((const char **)MediaCdXpm);  
   CustomIconSet[8] = new QPixmap((const char **)MediaFloppyXpm);  
   CustomIconSet[9] = new QPixmap((const char **)MediaHardDiskXpm);  
   CustomIconSet[10] = new QPixmap((const char **)MediaNetworkXpm);  
   CustomIconSet[11] = new QPixmap((const char **)MediaDatabaseXpm);  
   
   SetState(0);
}
