/*=============================================================================

    Copyright (C) 2001 Silicon Tao Technology Systems
    E-mail:  Support <support@silicontao.com>
    Web:     www.silicontao.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
=============================================================================*/

/*=============================================================================
   ToDo:
      - test speed of new VS malloc VS STMalloc      
      - Make more efficent. It is inefficent to malloc 8 bytes of memory to store
        4 bytes of data. It should really use an array of about 100 ints that is
        a block that can be malloced and freeed by the block. That way 100 ints 
        can be stored into 404 bytes insted of 800 bytes.

=============================================================================*/

/*=============================================================================
   Note:
      - STMalloc uses STList to track memory leeks so STIntList can not use
        STMalloc to get memory.

=============================================================================*/

#include <STIntList.h>

STIntList::STIntList() 
:  STList()
{
   //
}

STIntList::~STIntList()
{
   STIntList::Clear();
}

void STIntList::Add(int NewInt)
{
   int *NewIntPointer;
   
   NewIntPointer = (int *)malloc(sizeof(int));
   *NewIntPointer = NewInt;
   STList::Add(NewIntPointer);
}

void STIntList::Delete(int CellToKill)
{
   int *NewIntPointer;
   
   NewIntPointer = (int *)STList::Item(CellToKill);
   free(NewIntPointer);
   STList::Delete(CellToKill);
}

void STIntList::Clear()
{
   unsigned int ALoopCounter,ListCount;
   
   ListCount = Count();
   for(ALoopCounter = 0;ALoopCounter < ListCount;ALoopCounter++)
   {
      STIntList::Delete(0);   
   }   
}

int STIntList::Item(int ItemIndex)
{
   int *NewIntPointer;
   int TempReturn;
   
   NewIntPointer = (int *)STList::Item(ItemIndex);
   TempReturn = *NewIntPointer;
   
   return(TempReturn);
}























