/*=============================================================================

    Copyright (C) 2001 Silicon Tao Technology Systems
    E-mail:  Support <support@silicontao.com>
    Web:     www.silicontao.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
=============================================================================*/

/*=============================================================================
   ToDo:

=============================================================================*/

#include <STParserOps.h>
//#include "STParserOps.h"

STParserOps::STParserOps()
: STObjectController()
{

}

STParserOps::~STParserOps()
{
}

QString STParserOps::RemoveFrontAndBackChars(QString &TextString, QString &TheChar)
{
   ReturnString = "";
   printf("ERROR! Your data is wrong because this function is not writen yet!\
      STParserOps::RemoveFrontAndBackChars\n");
   return(ReturnString);
}

bool STParserOps::WildCardCompairStrings(QString &OriginalString1,QString &OriginalString2, bool CaseSensitive)
{
   QString Constructed1;
   QString PartString1;
   QString CompairString1,CompairString2;
   bool Done, TempReturn;
   int NestAsteriks, NextQMark;
   int Position1, Position2;
   QChar RemoveChar;
   bool Stripped;
   
   CompairString1 = OriginalString1;
   CompairString2 = OriginalString2;

   if(DebugLevel > 2)
   {
      printf(" - CompairString1 = %s , CompairString2 = %s\n",(const char *)CompairString1,
         (const char *)CompairString2);
   }
   
   Done = false;
   PartString1 = "";
   TempReturn = false;
     
   if((CompairString1 > "")&&(CompairString2 > ""))
   {      
      // Strip unwanted chars from front and back
      Stripped = false;
      while(Stripped == false)
      {
         Stripped = true;      
         RemoveChar = CompairString1[0];
      
         if(DebugLevel > 2)
         {
            printf("Stripping CompairString1[0]\n");
         }

         // Because a char is signed, this will remove any abs < 32 and > 127
         if(RemoveChar < 33)
         {
            CompairString1.remove(0,1);
            Stripped = false;
         }
         if(CompairString1 == "")
         {
            break;
         }
      }
      Stripped = false;
      while(Stripped == false)
      {
         Stripped = true;      

         if(DebugLevel > 2)
         {
            printf("Stripping CompairString1[CompairString1.length()-1]\n");
         }

         // Because a char is signed, this will remove any abs < 32 and > 127
         RemoveChar = CompairString1[CompairString1.length()-1];
         if(RemoveChar < 33)
         {
            CompairString1.remove(CompairString1.length()-1,1);
            Stripped = false;
         }
         if(CompairString1 == "")
         {
            break;
         }
      }
      Stripped = false;
      while(Stripped == false)
      {
         Stripped = true;      
         RemoveChar = CompairString2[0];
      
         if(DebugLevel > 2)
         {
            printf("Stripping CompairString2[0]\n");
         }

         // Because a char is signed, this will remove any abs < 32 and > 127
         if(RemoveChar < 33)
         {
            CompairString2.remove(0,1);
            Stripped = false;
         }
         if(CompairString2 == "")
         {
            break;
         }
      }
      Stripped = false;
      while(Stripped == false)
      {
         Stripped = true; 
           
         if(DebugLevel > 2)
         {
            printf("Stripping CompairString2[CompairString2.length()-1]\n");
         }

         // Because a char is signed, this will remove any abs < 32 and > 127
         RemoveChar = CompairString2[CompairString2.length()-1];
         if(RemoveChar < 33)
         {
            CompairString2.remove(CompairString2.length()-1,1);
            Stripped = false;
         }
         if(CompairString2 == "")
         {
            break;
         }
      }
   }
   
      
   // Make CompairString1 the wildcard string   
   NestAsteriks = CompairString2.find('*',0,CaseSensitive);
   NextQMark = CompairString2.find('?',0,CaseSensitive);

   if((NestAsteriks > -1)||(NextQMark > -1))
   {
      Constructed1 = CompairString2;
      CompairString2 = CompairString1;
      CompairString1 = Constructed1;
   }
         
   // Both strings can't have wildcards
   NestAsteriks = CompairString2.find('*',0,CaseSensitive);
   NextQMark = CompairString2.find('?',0,CaseSensitive);
   if(! ((NestAsteriks > -1)||(NextQMark > -1)))
   {
      TempReturn = true;
      while(Done == false)
      {
         if(DebugLevel > 2)
         {
            printf("Testing strings\n");
         }
         
         NestAsteriks = CompairString1.find('*',0,CaseSensitive);
         NextQMark = CompairString1.find('?',0,CaseSensitive);

         if(NestAsteriks == 0)
         {
            if(DebugLevel > 2)
            {
               printf("NestAsteriks = 0 in %s\n",(const char *)CompairString1);
            }
 
            // Remove from Par CompairString1 the leading wildcard
            // Two leading wildcards in a row are rejected, first wild card is used
            while((NestAsteriks == 0)||(NextQMark == 0)) 
            {
               CompairString1.remove(0,1);
               NestAsteriks = PartString1.find('*',0,CaseSensitive);
               NextQMark = PartString1.find('?',0,CaseSensitive);
            }

            PartString1 = CompairString1;

            // Remove from PartString1 any thing after the next wildcard 
            // If there are no more wildcards then CompairString1 must = CompairString2
            NestAsteriks = PartString1.find('*',0,CaseSensitive);
            NextQMark = PartString1.find('?',0,CaseSensitive);
            if((NestAsteriks > -1)&&((NestAsteriks < NextQMark)||(NextQMark == -1)))
            {
               PartString1.remove(NestAsteriks,PartString1.length());
            } else
            if((NextQMark > -1)&&((NextQMark < NestAsteriks)||(NestAsteriks == -1)))
            {
               PartString1.remove(NextQMark,PartString1.length());
            } else
            if((NestAsteriks == -1)&&(NextQMark == -1))
            {
               CompairString1 = PartString1;
            }

            // If PartString1 is found in CompairString2 anywhere then 
            // Remove every thing up to that point
            if(CompairString2.find(PartString1,0,CaseSensitive) > -1)
            {
               Position1 = CompairString2.find(PartString1,0,CaseSensitive);
               CompairString2.remove(0,Position1);
            }

            // At this point in the code it is posible that CompairString1 is 
            // empty because it's last char was a star, if so it is a match
            if(CompairString1 == "") 
            {
               break;
            }

            // At this point in the code PartString1 should be at the start of
            // CompairString1 and CompairString2 delete them and search again
            Position1 = CompairString2.find(PartString1,0,CaseSensitive);
            //printf("Position1 = %s , CompairString2 = %s\n",(const char *)PartString1,
            //   (const char *)CompairString2);
            if(Position1 > -1)
            {
               if(DebugLevel > 2)
               {
                  printf("CompairString1 = %s , CompairString2 = %s\n",(const char *)CompairString1,
                     (const char *)CompairString2);
               }
               CompairString1.remove(0,PartString1.length());
               CompairString2.remove(0,PartString1.length());

               if(WildCardCompairStrings(CompairString1,CompairString2,CaseSensitive)==false)
               {
                  TempReturn = false;
                  Position1 = CompairString2.find(PartString1,0,CaseSensitive);
                  while(Position1 > -1)
                  {
                     Position1 = CompairString2.find(PartString1,0,CaseSensitive);
                     CompairString2.remove(0,Position1-1);
                     CompairString2.remove(0,PartString1.length());
                     if(DebugLevel > 2)
                     {
                        printf("CompairString1 = %s , CompairString2 = %s\n",(const char *)CompairString1,
                           (const char *)CompairString2);
                     }
                     if(WildCardCompairStrings(CompairString1,CompairString2,CaseSensitive)==true) 
                     {
                        //printf("we keep it\n");
                        TempReturn = true;
                        break;
                     }
                  }
               } else
               // CompairString1 & CompairString2 could both be blank now
               if(CompairString1 == CompairString2)
               {                 
                  TempReturn = true;                  
               }
            } else
            {
               //printf("problem with it\n");
               TempReturn = false;
            }
            Done = true;
         } else
         if(NextQMark == 0) 
         {
            if(DebugLevel > 2)
            {
               printf("NextQMark = 0 in %s\n",(const char *)CompairString1);
            }
            // Remove from Par CompairString1 the leading wildcard
            // Two leading wildcards in a row are rejected, first wild card is used
            while((NestAsteriks == 0)||(NextQMark == 0))
            {
               CompairString1.remove(0,1);
               NestAsteriks = PartString1.find('*',0,CaseSensitive);
               NextQMark = PartString1.find('?',0,CaseSensitive);
            }

            PartString1 = CompairString1;

            NestAsteriks = PartString1.find('*',0,CaseSensitive);
            NextQMark = PartString1.find('?',0,CaseSensitive);

            // Remove from PartString1 any thing after the next wildcard }
            // If there are no more wildcards then CompairString1 must = CompairString2 }
            if((NestAsteriks > -1)&&((NestAsteriks < NextQMark)||(NextQMark == -1)))
            {
               PartString1.remove(NestAsteriks,PartString1.length());
            } else
            if((NextQMark > -1)&&((NextQMark < NestAsteriks)||(NestAsteriks == -1)))
            {
               PartString1.remove(NextQMark,PartString1.length());
            } else
            if((NestAsteriks == -1)&&(NextQMark == -1)) 
            {
               CompairString1 = PartString1;
            }

            // If PartString1 is found in CompairString2 @ ? allowed location then }
            // Remove every thing up to that point }
            if(CompairString2.find(PartString1,0,CaseSensitive) == 1)
            {
               CompairString2.remove(0,1);
            } else
            {
               //printf("died here 1\n");
               TempReturn = false;
               break;
            }

            // At this point in the code PartString1 should be at the start of }
            // CompairString1 and CompairString2 delete them and search again  }
            Position1 = CompairString2.find(PartString1,0,CaseSensitive);
            if(Position1 > -1)
            {
               CompairString1.remove(0,PartString1.length());
               CompairString2.remove(0,PartString1.length());
               TempReturn &= WildCardCompairStrings(CompairString1,CompairString2,CaseSensitive);
            } else
            {
               //printf("died here 2\n");
               TempReturn = false;
            }
            Done = true;
         } else
         if((NestAsteriks > -1)&&((NestAsteriks < NextQMark)||(NextQMark == -1)))
         {
            if(DebugLevel > 2)
            {
               printf("((NestAsteriks > -1)&&((NestAsteriks < NextQMark)||(NextQMark == -1)))\n");
               printf(" in %s\n",(const char*)CompairString1);
            }
            PartString1 = CompairString1;
            PartString1.remove(NestAsteriks,PartString1.length());
            Position2 = PartString1.length();
            CompairString1.remove(0,Position2);
            if(CompairString2.find(PartString1,0,CaseSensitive) == 0)
            {
               Position1 = PartString1.length();
               CompairString2.remove(0,Position1);
               TempReturn &= WildCardCompairStrings(CompairString1,CompairString2,CaseSensitive);
            } else
            {
               TempReturn = false;
            }
            Done = true;
         } else
         if((NextQMark > -1)&&((NextQMark < NestAsteriks)||(NestAsteriks == -1)))
         {
            if(DebugLevel > 2)
            {
               printf("((NextQMark > -1)&&((NextQMark < NestAsteriks)||(NestAsteriks == -1)))\n");
               printf(" in %s\n",(const char*)CompairString1);
            }
            PartString1 = CompairString1;
            PartString1.remove(NextQMark,PartString1.length());
            Position1 = CompairString1.find(PartString1,0,CaseSensitive);
            Position2 = Position1 + PartString1.length();
            CompairString1.remove(Position1,Position2);
            if(CompairString2.find(PartString1,0,CaseSensitive)==0)
            {
               Position1 = PartString1.length();
               CompairString2.remove(0,Position1);
               TempReturn &= WildCardCompairStrings(CompairString1,CompairString2,CaseSensitive);
            } else
            {
               TempReturn = false;
            }
            Done = true;
         } else
         if((NestAsteriks == -1)&&(NextQMark == -1))
         {
            if(DebugLevel > 2)
            {
               printf("((NestAsteriks == -1)&&(NextQMark == -1))\n");
               printf(" in %s\n",(const char*)CompairString1);
            }
            if(CompairString1 != CompairString2)
            {
               TempReturn = false;
            }
            Done = true;
         } else
         {
            if(DebugLevel > 2)
            {
               printf("NestAsteriks = %d, NextQMark = %d\n",NestAsteriks,NextQMark);
            }         
         }
      }
   }
   return(TempReturn);
}

QString STParserOps::ExtractWord(QString &SourceString, int WordIndex)
{
   ReturnString = "";
   printf("ERROR! Your data is wrong because this function is not writen yet! STParserOps::ExtractWord\n");
   return(ReturnString);

}

QString STParserOps::RemoveWord(QString &SourceString, int WordIndex)
{
   ReturnString = "";
   printf("ERROR! Your data is wrong because this function is not writen yet! STParserOps::RemoveWord\n");
   return(ReturnString);

}

QString STParserOps::TrucateUpToWord(QString &SourceString, int WordIndex)
{
   ReturnString = "";
   printf("ERROR! Your data is wrong because this function is not writen yet! STParserOps::TrucateUpToWord\n");
   return(ReturnString);

}

QString STParserOps::TrucateAfterWord(QString &SourceString, int WordIndex)
{
   ReturnString = "";
   printf("ERROR! Your data is wrong because this function is not writen yet! STParserOps::TrucateAfterWord\n");
   return(ReturnString);

}

QString STParserOps::FindFirstWord(QString &SourceString)
{
   bool TestLetter;
   char LetterToTest;
   uint WordLength;
   
   WordLength = 0;
   ReturnString = SourceString;
   TestLetter = false;
   LetterToTest = (char)((QChar)ReturnString[0]); 
   TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
   TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
   while(TestLetter == false)
   {
      ReturnString.remove(0,1);
      if(ReturnString.length() == 0)
      {
         break;
      }
      LetterToTest = (char)((QChar)ReturnString[0]); 
      TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
      TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
   }
   if(ReturnString.length() > 0)
   {
      TestLetter = false;
      LetterToTest = (char)((QChar)ReturnString[0]);
      TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
      TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
      while(TestLetter == true)
      {
         WordLength++;
         if(WordLength >= ReturnString.length())
         {
            break;
         }
         TestLetter = false;
         LetterToTest = (char)((QChar)ReturnString[WordLength]);
         TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
         TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
      }
      ReturnString.remove(WordLength,ReturnString.length());
   }
   return(ReturnString);
}

QString STParserOps::FindNextWord(QString &SourceString, uint WordIndex)
{
   bool TestLetter;
   char LetterToTest;
   uint WordLength, ALoopCounter;
   
   WordLength = 0;
   ReturnString = SourceString;
   
   if(ReturnString.length() > 0)
   {
      TestLetter = false;
      LetterToTest = (char)((QChar)ReturnString[0]);
      TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
      TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
      while(TestLetter == false)
      {
         ReturnString.remove(0,1);
         if(ReturnString.length() == 0)
         {
            break;
         }
         LetterToTest = (char)((QChar)ReturnString[0]);
         TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
         TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
      }
   }

   for(ALoopCounter = 1;ALoopCounter < WordIndex;ALoopCounter++)
   {
      if(ReturnString.length() > 0)
      {
         TestLetter = false;
         LetterToTest = (char)((QChar)ReturnString[0]);
         TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
         TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
         while(TestLetter == true)
         {
            ReturnString.remove(0,1);
            if(ReturnString.length() == 0)
            {
               break;
            }
            TestLetter = false;
            LetterToTest = (char)((QChar)ReturnString[0]);
            TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
            TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
         }
      }
      if(ReturnString.length() > 0)
      {
         TestLetter = false;
         LetterToTest = (char)((QChar)ReturnString[0]);
         TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
         TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
         while(TestLetter == false)
         {
            ReturnString.remove(0,1);
            if(ReturnString.length() == 0)
            {
               break;
            }
            LetterToTest = (char)((QChar)ReturnString[0]);
            TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
            TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
         }
      }
      if(ReturnString.length() == 0)
      {
         break;
      }
   }
   if(ReturnString.length() > 0)
   {
      /*TestLetter = false;
      LetterToTest = (char)((QChar)ReturnString[0]);
      TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
      TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
      while(TestLetter == false)
      {
         ReturnString.remove(0,1);
         if(ReturnString.length() == 0)
         {
            break;
         }
         LetterToTest = (char)((QChar)ReturnString[0]);
         TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
         TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
      }*/
      
      TestLetter = false;
      LetterToTest = (char)((QChar)ReturnString[0]);
      TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
      TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
      while(TestLetter == true)
      {
         WordLength++;
         if(WordLength >= ReturnString.length())
         {
            break;
         }
         TestLetter = false;
         LetterToTest = (char)((QChar)ReturnString[WordLength]);
         TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
         TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
      }
      ReturnString.remove(WordLength,ReturnString.length());
   }
   return(ReturnString);
}

QString STParserOps::FindFirstIdentifier(QString &SourceString)
{
   bool TestLetter;
   char LetterToTest;
   uint WordLength;
   
   WordLength = 0;
   ReturnString = SourceString;
   TestLetter = false;
   LetterToTest = (char)((QChar)ReturnString[0]); 
   TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
   TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
   TestLetter |= ((LetterToTest >= '0')&&(LetterToTest <= '9'));
   while(TestLetter == false)
   {
      ReturnString.remove(0,1);
      if(ReturnString.length() == 0)
      {
         break;
      }
      LetterToTest = (char)((QChar)ReturnString[0]); 
      TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
      TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
      TestLetter |= ((LetterToTest >= '0')&&(LetterToTest <= '9'));      
   }
   if(ReturnString.length() > 0)
   {
      TestLetter = false;
      LetterToTest = (char)((QChar)ReturnString[0]);
      TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
      TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
      TestLetter |= ((LetterToTest >= '0')&&(LetterToTest <= '9'));
      while(TestLetter == true)
      {
         WordLength++;
         if(WordLength >= ReturnString.length())
         {
            break;
         }
         TestLetter = false;
         LetterToTest = (char)((QChar)ReturnString[WordLength]);
         TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
         TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
         TestLetter |= ((LetterToTest >= '0')&&(LetterToTest <= '9'));
      }
      ReturnString.remove(WordLength,ReturnString.length());
   }
   return(ReturnString);
}

QString STParserOps::FindNextIdentifier(QString &SourceString, uint IdentifierIndex)
{
   bool TestLetter;
   char LetterToTest;
   uint WordLength, ALoopCounter;
   
   WordLength = 0;
   ReturnString = SourceString;

   if(ReturnString.length() > 0)
   {
      TestLetter = false;
      LetterToTest = (char)((QChar)ReturnString[0]);
      TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
      TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
      TestLetter |= ((LetterToTest >= '0')&&(LetterToTest <= '9'));
      while(TestLetter == false)
      {
         ReturnString.remove(0,1);
         if(ReturnString.length() == 0)
         {
            break;
         }
         LetterToTest = (char)((QChar)ReturnString[0]);
         TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
         TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
         TestLetter |= ((LetterToTest >= '0')&&(LetterToTest <= '9'));      
      }
   }

   for(ALoopCounter = 1;ALoopCounter < IdentifierIndex;ALoopCounter++)
   {
      if(ReturnString.length() > 0)
      {
         TestLetter = false;
         LetterToTest = (char)((QChar)ReturnString[0]);
         TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
         TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
         TestLetter |= ((LetterToTest >= '0')&&(LetterToTest <= '9'));
         while(TestLetter == true)
         {
            ReturnString.remove(0,1);
            if(ReturnString.length() == 0)
            {
               break;
            }
            TestLetter = false;
            LetterToTest = (char)((QChar)ReturnString[0]);
            TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
            TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
            TestLetter |= ((LetterToTest >= '0')&&(LetterToTest <= '9'));      
         }
      }
      if(ReturnString.length() > 0)
      {
         TestLetter = false;
         LetterToTest = (char)((QChar)ReturnString[0]);
         TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
         TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
         TestLetter |= ((LetterToTest >= '0')&&(LetterToTest <= '9'));
         while(TestLetter == false)
         {
            ReturnString.remove(0,1);
            if(ReturnString.length() == 0)
            {
               break;
            }
            LetterToTest = (char)((QChar)ReturnString[0]);
            TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
            TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
            TestLetter |= ((LetterToTest >= '0')&&(LetterToTest <= '9'));      
         }
      }
      if(ReturnString.length() == 0)
      {
         break;
      }
   }
   if(ReturnString.length() > 0)
   {
      /*TestLetter = false;
      LetterToTest = (char)((QChar)ReturnString[0]);
      TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
      TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
      TestLetter |= ((LetterToTest >= '0')&&(LetterToTest <= '9'));
      while(TestLetter == false)
      {
         ReturnString.remove(0,1);
         if(ReturnString.length() == 0)
         {
            break;
         }
         LetterToTest = (char)((QChar)ReturnString[0]);
         TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
         TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
         TestLetter |= ((LetterToTest >= '0')&&(LetterToTest <= '9'));      
      }*/
      TestLetter = false;
      LetterToTest = (char)((QChar)ReturnString[0]);
      TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
      TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
      TestLetter |= ((LetterToTest >= '0')&&(LetterToTest <= '9'));
      while(TestLetter == true)
      {
         WordLength++;
         if(WordLength >= ReturnString.length())
         {
            break;
         }
         TestLetter = false;
         LetterToTest = (char)((QChar)ReturnString[WordLength]);
         TestLetter |= ((LetterToTest >= 'A')&&(LetterToTest <= 'Z'));
         TestLetter |= ((LetterToTest >= 'a')&&(LetterToTest <= 'z'));
         TestLetter |= ((LetterToTest >= '0')&&(LetterToTest <= '9'));
      }
      ReturnString.remove(WordLength,ReturnString.length());
   }
   return(ReturnString);
}

bool STParserOps::IsAlpha(char TheChar)
{
   printf("ERROR! Your data is wrong because this function is not writen yet! STParserOps::IsAlpha\n");
   return(false);

}

bool STParserOps::IsNumber(char TheChar)
{
   printf("ERROR! Your data is wrong because this function is not writen yet! STParserOps::IsNumber\n");
   return(false);

}

bool STParserOps::IsSymbole(char TheChar)
{
   printf("ERROR! Your data is wrong because this function is not writen yet! STParserOps::IsSymbole\n");
   return(false);
}

QString STParserOps::ExtractBlock(QString &SourceString, int BlockIndex, QString &BlockIndicators)
{
   ReturnString = "";
   printf("ERROR! Your data is wrong because this function is not writen yet! STParserOps::ExtractBlock\n");
   return(ReturnString);

}

QString STParserOps::RemoveBlock(QString &SourceString, int BlockIndex, QString &BlockIndicators)
{
   ReturnString = "";
   printf("ERROR! Your data is wrong because this function is not writen yet! STParserOps::RemoveBlock\n");
   return(ReturnString);

}

QString STParserOps::ExtractNumberString(QString &SourceString, int WordIndex)
{
   ReturnString = "";
   printf("ERROR! Your data is wrong because this function is not writen yet! STParserOps::ExtractNumberString\n");
   return(ReturnString);
}


