/*=============================================================================

    Copyright (C) 2001 Silicon Tao Technology Systems
    E-mail:  Support <support@silicontao.com>
    Web:     www.silicontao.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
=============================================================================*/

/*=============================================================================
   ToDo:

=============================================================================*/

#include <STPasswordDialog.h>

STPasswordDialog::STPasswordDialog( QWidget* parent,  const char* name, bool modal, WFlags fl )
: STPasswordDialogGUI( parent, name, modal, fl )
{
   UserHasSelected = false;
   ThePassword = "";
   LineEdit1->setFocus();
   EnterButton->setDefault(true);
   connect(EnterButton,SIGNAL(clicked()),SLOT(OnEnterButtonClick()));
   connect(QuitButton,SIGNAL(clicked()),SLOT(OnQuitButtonClick()));
}

STPasswordDialog::~STPasswordDialog()
{
   //printf("bye\n");
}

void STPasswordDialog::OnQuitButtonClick()
{
   ThePassword = "";
   LineEdit1->setText("");
   UserHasSelected = true;
   close();
}

void STPasswordDialog::OnEnterButtonClick()
{
   QString EnterdString;
   
   EnterdString = LineEdit1->text();
   if(EnterdString.length() > 0)
   {
      ThePassword = EnterdString;
      UserHasSelected = true;
      close();
   }
}

QString STPasswordDialog::UserEnteredPassword()
{
   //ThePassword = LineEdit1->text();
   return(ThePassword);
}


void STPasswordDialog::closeEvent(QCloseEvent *EventPointer)
{
   if(UserHasSelected == false)
   {
      EventPointer->ignore();
   } else
   {
      EventPointer->accept();
   }
}

