/*=============================================================================

    Copyright (C) 2001 Silicon Tao Technology Systems
    E-mail:  Support <support@silicontao.com>
    Web:     www.silicontao.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
=============================================================================*/

#include <STStringsEx.h>
#include <stdio.h>

int STStringsEx::LastPos(const char *SubString, QString &TheFullString)
{
   QString TempSub;
   
   TempSub = "";
   TempSub += SubString;
   return(LastPos(TempSub,TheFullString));
}

int STStringsEx::LastPos(const char SubString, QString &TheFullString)
{
   QString TempSub;
   
   TempSub = "";
   TempSub += SubString;
   return(LastPos(TempSub,TheFullString));
}

int STStringsEx::LastPos(QString &SubString, QString &TheFullString)
{
   QString ParsingString;
   int TempReturn;
   
   ParsingString = TheFullString;
   TempReturn = 0;
   while(ParsingString.find(SubString,0,false) > -1)
   {
      TempReturn += ParsingString.find(SubString,0,false) + 1;
      ParsingString.remove(0,ParsingString.find(SubString,0,false)+1);
   }
   return(TempReturn-1);
}

int STStringsEx::InsertCrLf(QString *InsertingToString, int SpaceNear, char CrLfChar)
{
   bool Done;
   int LastCrLf, ALoopCounter;
   int InsertPoint;
   int NumberOfTextLines;
   QString CopiedString;
   QChar ShortString;
      
   ShortString=CrLfChar;
   Done=false;
   NumberOfTextLines=1;
   while(Done==false)
   {
      Done=true;
      LastCrLf=0;
      InsertPoint=0;
      CopiedString=InsertingToString[0];
      for(ALoopCounter=0;ALoopCounter<(int)InsertingToString->length();ALoopCounter++)
      {
         if(CopiedString[ALoopCounter]==CrLfChar)
         {
            LastCrLf=0;
         } else
         if(CopiedString[ALoopCounter]==' ')
         {       
            InsertPoint=ALoopCounter;
         } else
         {
            LastCrLf++;
         }
         if((LastCrLf>SpaceNear)&&(InsertPoint>0))
         {
            InsertingToString->replace(InsertPoint,1,&ShortString,1);
            NumberOfTextLines++;
            Done=false;
            break;
         }
      }
   }
   return(NumberOfTextLines);
}

void STStringsEx::HexStr2Ascii(QString &SourceString, QString &DestinationString,
   bool MaskLow,bool MaskHi, char MaskChar)
{
   int ByteValue;
   char TempChar;
   QString ParsingString;
   QString ConvertByte, DecByte;
   
   DestinationString="";
   ParsingString=SourceString;   
   while(ParsingString.length()>0)
   {
      stripChars(ParsingString,' ');
      if(ParsingString.find("0x",0,false)==0)
      {
         ParsingString.remove(0,2);
      }
      ConvertByte=ParsingString;
      ConvertByte.remove(2,ConvertByte.length());
      ParsingString.remove(0,2);      
      Hex2Dec(ConvertByte,DecByte);
      ByteValue=DecByte.toInt(0,10);
      TempChar=ByteValue;
      if((MaskLow==true)&&(TempChar>0)&&(TempChar<32))
      {
         TempChar=MaskChar;  
      }
      DestinationString+=TempChar;        
   }
}

QString STStringsEx::stripClean(QString &TheString)
{
   bool Done, KillThisChar;
   QChar TestChar;
   QString TempReturnString;
   
   TempReturnString = TheString;
   
   // Leading any thing is removed if not A-Z or a-z or 0-9
   Done=false;
   while(Done==false)
   {
      KillThisChar=true;
      TestChar=TempReturnString[0];
      //printf(" b length = %d ",TempReturnString.length());
      if((TestChar>='A')&&(TestChar<='Z'))
      {
         KillThisChar=false;
      } else
      if((TestChar>='a')&&(TestChar<='z'))
      {
         KillThisChar=false;
      } else
      // Note: Integer leading blocks must be qualified by the caller.
      if((TestChar>='0')&&(TestChar<='9'))
      {
         KillThisChar=false;
      }
      //printf(" c = %d\n",(char)TestChar);
      
      
      if(KillThisChar==true)
      {
         TempReturnString.remove(0,1);
      } else
      {
         Done=true;
      }
      if(TempReturnString.length() == 0)
      {
         Done=true;
      }
   }
   
   // Trailing any thing is removed if not A-Z or a-z or 0-9
   Done=false;
   while(Done==false)
   {
      //printf(" e length = %d ",TempReturnString.length());
      KillThisChar=true;
      TestChar=TempReturnString[TempReturnString.length()-1];
      if((TestChar>='A')&&(TestChar<='Z'))
      {
         KillThisChar=false;
      } else
      if((TestChar>='a')&&(TestChar<='z'))
      {
         KillThisChar=false;
      } else
      // Note: Integer leading blocks must be qualified by the caller.
      if((TestChar>='0')&&(TestChar<='9'))
      {
         KillThisChar=false;
      }
      //printf(" c = %d\n",(char)TestChar);
      
      if(KillThisChar==true)
      {
         TempReturnString.remove(TempReturnString.length()-1,1);
      } else
      {
         Done=true;
      }
      if(TempReturnString.length() == 0)
      {
         Done=true;
      }
   }   
   ReturnString = TempReturnString;
   return(ReturnString);
}

void STStringsEx::ParseIdentifier(QString &TheString, int IdentifierIndex)
{
   QString BuildString;
   bool Done, KillThisChar;
   QChar TestChar;
   int IndexCounter;
   
   BuildString="";
   Done=false;
   while(Done==false)
   {
      KillThisChar=true;
      TestChar=TheString[0];
      if((TestChar>='A')&&(TestChar<='Z'))
      {
         KillThisChar=false;
      } else
      if((TestChar>='a')&&(TestChar<='z'))
      {
         KillThisChar=false;
      } else
      // Note: Integer leading blocks must be qualified by the caller.
      if((TestChar>='0')&&(TestChar<='9'))
      {
         KillThisChar=false;
      }
      
      // Move char to destination
      if(KillThisChar==false)
      {
         BuildString+=TestChar;
      } else
      {
         if(BuildString.length()>0) 
         {
            if(IdentifierIndex==IndexCounter)
            {
               Done=true;
               TheString=BuildString;
               break;
            }
         }
         TheString.remove(0,1);
      }         
   }
}

QString STStringsEx::stripChars(QString &TheString,char TheChar)
{
   QString TempReturnString;
   
   TempReturnString = TheString;
   while(TempReturnString[0]==TheChar)
   {
      TempReturnString.remove(0,1);   
   }
   while(TempReturnString[TempReturnString.length()-1]==TheChar)
   {      
      TempReturnString.remove(TempReturnString.length()-1,1);   
   }  
   ReturnString = TempReturnString;
   return(ReturnString);
}

void STStringsEx::Bin2Dec(QString &SourceString, QString &DestinationString)
{
   int ReturnValue;
   bool LeadingCrap;
   
   ReturnValue=0;
   LeadingCrap=true;
   while(LeadingCrap==true)
   {
      if((SourceString[0]!='0')&&(SourceString[0]!='1')&&(SourceString[0]>0))
      {
         SourceString.remove(0,1);           
      } else
      {
         LeadingCrap=false;
      }      
   }
   while(SourceString[0]>0)
   {
      ReturnValue*=2;
      
      if(SourceString[0]=='1')
      {
         ReturnValue++;
      } else
      if(SourceString[0]!='0')
      {
         break;
      }
      SourceString.remove(0,1);  
   }
   DestinationString.sprintf("%d",ReturnValue);
}

void STStringsEx::Hex2Dec(QString &SourceString, QString &DestinationString)
{
   int HexLength, ExponentValue, CounterValue, DecNumber;
   QChar TempValue;
   char RealChar;
   QString ParsingString;
   
   ParsingString=SourceString.upper();
   CounterValue=0;
   DecNumber=0;
   TempValue=0;
   HexLength=ParsingString.length()-1;
   ExponentValue=HexLength;
   while(CounterValue<=HexLength)
   {
      // Letter from A to F
      if((SourceString[CounterValue]>='A')&&(SourceString[CounterValue]<='F'))
      {
         // 'A' - 9 = 55
         TempValue=SourceString[CounterValue];
         //TempValue+=55;
         RealChar=TempValue;
         RealChar-=55;
      } else
      // Number from 0 to 9
      if((SourceString[CounterValue]>='0')&&(SourceString[CounterValue]<='9'))
      {
         // '0' = 48
         TempValue=SourceString[CounterValue];
         RealChar=TempValue;
         RealChar-=48;
      } else
      // Invalid
      {
         DecNumber=0;
         break;
      }
      DecNumber+=RealChar*power(16,ExponentValue);      
      CounterValue++;
      ExponentValue--;
   }
   DestinationString.sprintf("%d",DecNumber);
}

void STStringsEx::Dec2Hex(QString &SourceString, QString &DestinationString)
{
   int TheIntValue, RemainderValue;
   char AddChar;
   
   TheIntValue=SourceString.toInt(0,10);
   DestinationString="";
   while(TheIntValue>0)
   {
      RemainderValue=TheIntValue % 16;
      TheIntValue /= 16;
      if(RemainderValue>9)
      {
         // 'A' - 9 = 55
         AddChar=RemainderValue + 55;
      } else
      {
         // '0' = 48
         AddChar=RemainderValue + 48;
      }
      DestinationString=AddChar+DestinationString;
   }
   while(DestinationString.length() % 2)
   {
      DestinationString='0'+DestinationString;
   }   
}


