/*=============================================================================

    Copyright (C) 2001 Silicon Tao Technology Systems
    E-mail:  Support <support@silicontao.com>
    Web:     www.silicontao.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
=============================================================================*/

/*=============================================================================
   ToDo:

=============================================================================*/

#include <STSystemAPI.h>

STSystemAPI::STSystemAPI()
{
}

STSystemAPI::~STSystemAPI()
{
}

int STSystemAPI::GetAppPid()
{
   pid_t ThisAppsPid;
   
   ThisAppsPid = getpid();
   return(ThisAppsPid);   
}

QString STSystemAPI::GetAppNameFromPid(int ProcessID)
{
   QString FileName, ResultData;
   int OpenFileIndex;
   char Buffer[4096];
   int ReadLength;
   
   ReturnString = "";
   FileName.sprintf("/proc/%d/stat",ProcessID);

   // Open file, read in a block, close file
   OpenFileIndex = open(FileName,O_RDONLY);   
   ReadLength = read(OpenFileIndex, Buffer, sizeof(Buffer)-1);   
	close(OpenFileIndex);
   Buffer[ReadLength] = '\0';
   ResultData = Buffer;

   ResultData.remove(0,ResultData.find('(',1,false)+1);            
   ResultData.remove(ResultData.find(')',1,false),ResultData.length()+1);               
   
   ReturnString = ResultData;
   return(ReturnString);
}

void STSystemAPI::GetIpAddresses(STStringList *FillAddressList)
{
   char *TheSystemName;
   int LengthOfName;
   struct hostent *HostInfo;
   char MoveChar;
   int ALoopCounter;
   int BLoopCounter;
   QString IpAddressString;
   QString ConvertString;
   
   LengthOfName = 150; // Any one with a computer name longer then 150 need a beeting.
   TheSystemName = (char *)malloc(LengthOfName);
   if(gethostname(TheSystemName,(size_t)LengthOfName) == 0)
   {
      HostInfo = gethostbyname(TheSystemName);
      if(HostInfo != NULL)
      {
         BLoopCounter = 0;
         IpAddressString = "";
         for(ALoopCounter = 0;ALoopCounter < HostInfo->h_length;ALoopCounter++)
         {
            MoveChar = HostInfo->h_addr_list[BLoopCounter][ALoopCounter];
            ConvertString.sprintf("%d",(unsigned char)MoveChar);
            IpAddressString += ConvertString;
            if((ALoopCounter > 0)&&((ALoopCounter + 1) % 4) == 0)
            {
               FillAddressList->Add(IpAddressString);
               IpAddressString = "";
               BLoopCounter++;
            } else
            {
               IpAddressString += ".";
            }
         }
      } else
      {
         herror("gethostbyname");      
      }      
   } else
   {
      perror("gethostname");
   }
   free(TheSystemName);
}

void STSystemAPI::GetPidList(QString &AppName, STIntList *PidList,bool HoleMatch)
{
   // For now HoleMatch does not work
   
   DIR *DirectoryPointer;
	struct dirent *DirectoryEntry;
   pid_t ProcessID;
   QString TheAppName;
  
   DirectoryPointer = opendir("/proc/");
   
   DirectoryEntry = readdir(DirectoryPointer);
	while(DirectoryEntry != NULL)
	{      
      if(isdigit(DirectoryEntry->d_name[0]))
      {
         ProcessID = atoi(DirectoryEntry->d_name);
         TheAppName = GetAppNameFromPid(ProcessID);
         if((TheAppName.find(AppName,0,false) > -1) || (AppName == ""))
         {
            PidList->Add(ProcessID);
         }
      }
      DirectoryEntry = readdir(DirectoryPointer);
	}
	closedir(DirectoryPointer);
}

