/*=============================================================================

    Copyright (C) 2001 Silicon Tao Technology Systems
    E-mail:  Support <support@silicontao.com>
    Web:     www.silicontao.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
=============================================================================*/

#include "STTtlPanel.h"

STTtlPanel::STTtlPanel(QWidget *parent, const char *name,int PointsHi, int PointsWide)
: QFrame(parent, name), STWidgetsEx(this,name)
{
   //int *IntPointer;
   int ALoopCounter;
   
	// Constructor
   SetPointsHi = PointsHi;
   SetPointsWide = PointsWide;
   if(SetPointsWide > 999)
   {
      SetPointsWide = 1000;
   }
   resize(SetPointsWide + 10,SetPointsHi + 10);
   setFrameShadow(QFrame::Raised);
   setFrameShape(QFrame::StyledPanel);

   MinXPoint = 5;
   MaxXPoint = SetPointsWide + 5;
   MinYPoint = 5;
   MaxYPoint = SetPointsHi + 5;

   //PointList = new QGList();
   //for(ALoopCounter=0;ALoopCounter<SetPointsWide;ALoopCounter++)
   //{
   //   IntPointer = new int;
   //   *IntPointer = 0;
   //   PointList->append(IntPointer);
   //}      

   PreferedColor = Qt::blue;
   DrawRatio = 1;

   for(ALoopCounter=0;ALoopCounter<1000;ALoopCounter++)
   {
      IntPointer[ALoopCounter] = 0;
   }      
}

void STTtlPanel::ResetSize()
{
   SetPointsHi = height();
   SetPointsWide = width();
   if(SetPointsWide > 999)
   {
      SetPointsWide = 1000;
   }
   resize(SetPointsWide + 10,SetPointsHi + 10);
   setFrameShadow(QFrame::Raised);
   setFrameShape(QFrame::StyledPanel);

   MinXPoint = 5;
   MaxXPoint = SetPointsWide + 5;
   MinYPoint = 5;
   MaxYPoint = SetPointsHi + 5;
}

void STTtlPanel::SetPointRatio(int NewRatio)
{
   DrawRatio = NewRatio;
}

void STTtlPanel::SetPreferedColor(QColor SetColor)
{
   PreferedColor = SetColor;
   update();
}

// Draw during a paint event.
//void TTtlPanel::paintEvent(QPaintEvent *TheEventPointer)
//{
//   QFrame::paintEvent(TheEventPointer);
//   QPainter p(this);
//   p.setPen( Qt::red );
//   p.drawText(20,20,"QPaintEvent",11);
//   p.drawRect( 10, 6, 120, 20 );   
//}

void STTtlPanel::DrawVerticalLine(QPainter *Painter)
{
   Painter->setPen( PreferedColor );
   Painter->drawLine(DrawXPoint,MinYPoint,DrawXPoint,MaxYPoint);
}

void STTtlPanel::TogelState()
{
   SetPoint(!CurrentState);
}

void STTtlPanel::Advance()
{
   SetPoint(CurrentState);
}

bool STTtlPanel::GetState()
{
   return(CurrentState);
}

void STTtlPanel::SetPoint(bool BitState)
{
   //int *IntPointer, *TempInt;
   int ALoopCounter,BLoopCounter;

   DrawXPoint = MinXPoint;

   CurrentState = BitState;
   
   for(BLoopCounter=0;BLoopCounter<DrawRatio;BLoopCounter++)
   {
      for(ALoopCounter=0;ALoopCounter<SetPointsWide-1;ALoopCounter++)
      {
         //TempInt = PointList->at(ALoopCounter);
         //IntPointer = PointList->at(ALoopCounter + 1);
         //*TempInt = *IntPointer;
         IntPointer[ALoopCounter] = IntPointer[ALoopCounter+1];
      }   
   
      //*IntPointer = BitState;
      IntPointer[ALoopCounter] = BitState;
   }
   update();
}

void STTtlPanel::drawContents(QPainter *Painter)
{
   //int *IntPointer;
   bool LastState;
   int ALoopCounter;

   LastState = IntPointer[0];
   Painter->setPen( PreferedColor );
   if(IntPointer[0])
   {
      DrawYPoint = MinYPoint;
   } else
   {
      DrawYPoint = MaxYPoint;
   }
   DrawXPoint = MinXPoint;

   for(ALoopCounter=0;ALoopCounter<SetPointsWide;ALoopCounter++)
   {
      //IntPointer = PointList->at(ALoopCounter);      
      //if(LastState != *IntPointer)
      if(LastState != IntPointer[ALoopCounter])
      {
         DrawVerticalLine(Painter);
         //if(*IntPointer)
         if(IntPointer[ALoopCounter])
         {
            DrawYPoint = MinYPoint;
         } else
         {
            DrawYPoint = MaxYPoint;
         }
      }
      Painter->drawPoint(DrawXPoint,DrawYPoint);
      DrawXPoint++;
      //LastState = *IntPointer;
      LastState = IntPointer[ALoopCounter];
   }   
}

STTtlPanel::~STTtlPanel()
{
   //int *IntPointer;
   //int ALoopCounter;

	// Destructor
   //for(ALoopCounter=0;ALoopCounter<SetPointsWide;ALoopCounter++)
   //{
   //   IntPointer = PointList->at(ALoopCounter);
   //   delete IntPointer;
   //}      
}



