#include "TForm.h"

TForm::TForm(QWidget *parent, const char *name)
: TFormGUI(parent, name)
{
   int ALoopCounter,BLoopCounter;
   QPushButton *ShorButtonName;
   int ButtonSize, XPosition, YPosition;   
   QPalette Palette;
   QColorGroup ColorGroup;
   
   CurrentLetter = 0;
   ButtonSize = 15;
   GridWidth = 12;
   GridHeight = 12;
   for(ALoopCounter = 0;ALoopCounter < GridWidth;ALoopCounter++)
   {
      for(BLoopCounter = 0;BLoopCounter < GridHeight;BLoopCounter++)
      {
         //printf("Making button ButtonGrid[%d][%d]\n",ALoopCounter,BLoopCounter);
         ShorButtonName = new QPushButton(GroupBox1,"GridButton");
         XPosition = ALoopCounter * (ButtonSize + 1) + 20;
         YPosition = BLoopCounter * (ButtonSize + 1) + 20;
         ShorButtonName->setGeometry(XPosition,YPosition,ButtonSize,ButtonSize);
         Palette = ShorButtonName->palette();
         
         //ColorGroup.setColor( QColorGroup::Base, Qt::black); 
         //ColorGroup.setColor( QColorGroup::Background, Qt::black); 
         //ColorGroup.setColor( QColorGroup::Foreground, Qt::black); 
         ColorGroup.setColor( QColorGroup::Button, Qt::black); 
         Palette.setActive(ColorGroup);
         Palette.setInactive(ColorGroup);
         //Palette.setDisabled(ColorGroup);
         ShorButtonName->setPalette( Palette );
         //Palette.setColor( QColorGroup::Button, Qt::black); 
         //ShorButtonName->setColor(Qt::black);
         //cg.setColor( QColorGroup::Button, QColor( 255, 255, 0) );
         //pal.setActive( cg );
         ShorButtonName->show();
         connect(ShorButtonName,SIGNAL(clicked()),SLOT(OnGridButtonClick()));
         ButtonGrid[ALoopCounter][BLoopCounter] = ShorButtonName;
      }
   }   
   connect(ThisCharEdit ,SIGNAL(textChanged(const QString &)),SLOT(OnTextChanged(const QString &)));
}

TForm::~TForm()
{
   // Destructor, put code here that needs to happen when this 
	// object is destroied.
}

void TForm::OnTextChanged(const QString &NewText)
{
   QString TheString;
   char NextLetter;

   //printf("key pressed\n");
   TheString = NewText;
   if(TheString.length() > 1)
   {
      TheString.remove(0,TheString.length() - 1);
      ThisCharEdit->setText(TheString);
   } else
   if(TheString.length() == 1)
   {
      NextLetter = (QChar)TheString[0];
      if(NextLetter != CurrentLetter)
      {
         if(CurrentLetter != 0)
         {
            SaveLetter();
         }
         CurrentLetter = NextLetter;
         LoadLetter();
      }
   }
}

void TForm::LoadLetter()
{
   STStringList FontSetFile;      
   int ALoopCounter,BLoopCounter;
   QString ThisLetterString;
   char DotValue;
   QPalette Palette;
   QButton *ReadButton;
   QPushButton *ColorThisButton;
   bool DefaultTheLine;
   
   if(CurrentLetter != 0)
   {
      DefaultTheLine = true;
      FontSetFile.LoadFromFile("test.set");
      for(ALoopCounter = 0;ALoopCounter < FontSetFile.Count();ALoopCounter++)
      {
         ThisLetterString = FontSetFile.Item(ALoopCounter);
         if(ThisLetterString.find(CurrentLetter,0,false) == 0)
         {
            DefaultTheLine = false;
            break;
         }
      }
      if(DefaultTheLine == true)
      {
         for(ALoopCounter = 0;ALoopCounter < GridWidth;ALoopCounter++)
         {
            for(BLoopCounter = 0;BLoopCounter < GridHeight;BLoopCounter++)
            {
               ColorThisButton = ButtonGrid[ALoopCounter][BLoopCounter];
               Palette = ColorThisButton->palette();
               Palette.setColor( QColorGroup::Button, Qt::black); 
               ColorThisButton->setPalette( Palette );                 
            }
         }        
      } else
      {  
         ThisLetterString.remove(0,ThisLetterString.find(" ",0,false)+1);
         ThisLetterString.remove(0,ThisLetterString.find(" ",0,false)+1);
         ThisLetterString.remove(0,ThisLetterString.find(" ",0,false)+1);
         ThisLetterString.remove(0,ThisLetterString.find(" ",0,false)+1);
         ALoopCounter = 0;
         BLoopCounter = 0;
         //printf("loading dot\n");
      
         while(ThisLetterString.length() > 0)
         {
            DotValue = (QChar)ThisLetterString[0];
            ThisLetterString.remove(0,1);
            if((DotValue == '1')||(DotValue == '0'))
            {
               //printf("set ButtonGrid[%d][%d] = %c\n",ALoopCounter,BLoopCounter,DotValue);
               //printf("ThisLetterString = %s\n",(const char *)ThisLetterString);
               ColorThisButton = ButtonGrid[ALoopCounter][BLoopCounter];
               Palette = ColorThisButton->palette();
               if(DotValue == '1')
               {
                  Palette.setColor( QColorGroup::Button, Qt::green); 
               } else
               {
                  Palette.setColor( QColorGroup::Button, Qt::black); 
               }
               ColorThisButton->setPalette( Palette );     
               BLoopCounter++;
               if(BLoopCounter >= GridHeight)
               {	
                  BLoopCounter = 0;
                  ALoopCounter++;
                  if(ALoopCounter >= GridWidth)
                  {
                     break;
                  }
               }
            }
         }
      }
   }
}

void TForm::SaveLetter()
{
   STStringList FontSetFile;      
   int ALoopCounter,BLoopCounter;
   QString ThisLetterString;
   bool InList;
   QString Dimensions;
   QPalette Palette;
   QButton *ReadButton;

   if(CurrentLetter != 0)
   {
      FontSetFile.LoadFromFile("test.set");
   
      InList = false;
      for(ALoopCounter = 0;ALoopCounter < FontSetFile.Count();ALoopCounter++)
      {
         ThisLetterString = FontSetFile.Item(ALoopCounter);
         if(ThisLetterString.find(CurrentLetter,0,false) == 0)
         {
            InList = true;
            FontSetFile.Delete(ALoopCounter);
            break;
         }
      }  
      Dimensions.sprintf(" w%02d h%02d ",GridWidth, GridHeight);
      if(FixedWidth == true)
      {
         Dimensions += "f1 ";
      } else
      {
         Dimensions += "f0 ";         
      }
      ThisLetterString = CurrentLetter + Dimensions;
      for(ALoopCounter = 0;ALoopCounter < GridWidth;ALoopCounter++)
      {
         for(BLoopCounter = 0;BLoopCounter < GridHeight;BLoopCounter++)
         {   
            ReadButton = ButtonGrid[ALoopCounter][BLoopCounter];
            Palette = ReadButton->palette();
            if( Qt::green == Palette.color(QPalette::Active, QColorGroup::Button))
            {
               ThisLetterString += "1";
            } else
            {
               ThisLetterString += "0";
            }
         }
         ThisLetterString += " ";         
      }
      FontSetFile.Add(ThisLetterString);
      FontSetFile.SaveToFile("test.set");
   }
}

void TForm::OnGridButtonClick()
{
   QPushButton *SenderButton;
   QPalette Palette;
   
   SenderButton = (QPushButton *)sender();
   Palette = SenderButton->palette();
   if( Qt::black == Palette.color(QPalette::Active, QColorGroup::Button))
   {
      Palette.setColor( QColorGroup::Button, Qt::green); 
   } else
   {
      Palette.setColor( QColorGroup::Button, Qt::black); 
   }
   SenderButton->setPalette( Palette );
}

void TForm::closeEvent(QCloseEvent *EventPointer)
{
   // When the form is closed this function will be called.
   // By default you can allow it to close or you can deny it
   // if you need to.
   EventPointer->accept();
   //EventPointer->ignore();
}

void TForm::showEvent(QShowEvent *EventPointer)
{
   // This function is called when the for is first showed.
   // This code will center the form on the screen, it is commanly used.
   int TopPosition, LeftPosition, FormWidth, FormHeight;
   
   FormWidth = width();
   FormHeight = height();
   LeftPosition = (qApp->desktop()->width() / 2) - (FormWidth / 2);
   TopPosition = (qApp->desktop()->height() / 2) - (FormHeight / 2);
   setGeometry(LeftPosition,TopPosition,FormWidth,FormHeight);     
}

/*
void TForm::OnTimer1TimeOut()
{
   // You could use this function to do things when the timer times out.
}
*/

